/*
 * Copyright (c) 2019. Baidu Inc. All Rights Reserved.
 */

package main

import "github.com/spf13/cobra"

// NativeCommand native cmd struct
type NativeCommand struct {
}

// NewNativeCommand new native cmd
func NewNativeCommand(cli *Cli) *cobra.Command {
	cmd := &cobra.Command{
		Use:   "native",
		Short: "Operate a native contract: deploy|upgrade|invoke|query",
	}
	cmd.AddCommand(NewContractDeployCommand(cli, "native"))
	cmd.AddCommand(NewContractInvokeCommand(cli, "native"))
	cmd.AddCommand(NewContractQueryCommand(cli, "native"))
	cmd.AddCommand(NewContractUpgradeCommand(cli))
	return cmd
}

func init() {
	AddCommand(NewNativeCommand)
}
